# Pathname creation utilities.
#
# Author::    Yutaka Yanoh <mailto:yanoh@users.sourceforge.net>
# Copyright:: Copyright (C) 2010-2012, OGIS-RI Co.,Ltd.
# License::   GPLv3+: GNU General Public License version 3 or later
#
# Owner::     Yutaka Yanoh <mailto:yanoh@users.sourceforge.net>

#--
#     ___    ____  __    ___   _________
#    /   |  / _  |/ /   / / | / /__  __/           Source Code Static Analyzer
#   / /| | / / / / /   / /  |/ /  / /                   AdLint - Advanced Lint
#  / __  |/ /_/ / /___/ / /|  /  / /
# /_/  |_|_____/_____/_/_/ |_/  /_/   Copyright (C) 2010-2012, OGIS-RI Co.,Ltd.
#
# This file is part of adlint-postfilter.
#
# adlint-postfilter is free software: you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the Free
# Software Foundation, either version 3 of the License, or (at your option) any
# later version.
#
# adlint-postfilter is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
# more details.
#
# You should have received a copy of the GNU General Public License along with
# adlint-postfilter.  If not, see <http://www.gnu.org/licenses/>.
#
#++

require "pathname"

module AdLint #:nodoc:
module Postfilter #:nodoc:

  module PathUtil
    def i_fpath_of(src_fpath, strip_num, output_dpath = nil)
      if output_dpath
        output_dpath.join(src_fpath.strip(strip_num)).sub_ext(".i")
      else
        src_fpath.strip(strip_num).sub_ext(".i")
      end
    end
    module_function :i_fpath_of

    def sma_msg_fpath_of(src_fpath, strip_num, output_dpath = nil)
      if output_dpath
        output_dpath.join(src_fpath.strip(strip_num)).add_ext(".msg.csv")
      else
        src_fpath.strip(strip_num).add_ext(".msg.csv")
      end
    end
    module_function :sma_msg_fpath_of

    def cma_msg_fpath_of(project_name, output_dpath = nil)
      if output_dpath
        output_dpath.join(Pathname.new(project_name)).add_ext(".msg.csv")
      else
        Pathname.new(project_name).add_ext(".msg.csv")
      end
    end
    module_function :cma_msg_fpath_of
  end

end
end
